OpenTTD Source: NWidgetContainer Class Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Protected Attributes
NWidgetContainer Class Reference
Hierarchical widgets

Baseclass for container widgets. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetContainer:

## Public Member Functions
| NWidgetContainer (WidgetType tp, WidgetID index=INVALID_WIDGET)
void | AdjustPaddingForZoom () override
void | Add (std::unique_ptr< NWidgetBase > &&wid)
| Append widget wid to container.
void | FillWidgetLookup (WidgetLookup &widget_lookup) override
| Fill the Window::widget_lookup with pointers to nested widgets in the tree.
void | Draw (const Window *w) override
| Draw the widgets of the tree.
NWidgetCore * | GetWidgetFromPos (int x, int y) override
| Retrieve a widget by its position.
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp) override
| Retrieve a widget by its type.
void | UnfocusWidgets (Window *parent_window)
| Unfocuses the focused widget of the window, if the focused widget is contained inside the container.
void | Clear (Window *parent_window)
| Clears the container, deleting all widgets that were contained.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp, WidgetID index=INVALID_WIDGET)
void | ApplyAspectRatio ()
virtual void | SetupSmallestSize (Window *w)=0
| Compute smallest size needed by the widget.
virtual void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl)=0
| Assign size and position to the widget.
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID.
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID.
WidgetID | GetIndex () const
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget.
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Rect | GetCurrentRect () const

## Protected Attributes
std::vector< std::unique_ptr< NWidgetBase > > | children {}
| Child widgets in container.
Protected Attributes inherited from NWidgetBase
const WidgetID | index = INVALID_WIDGET
| Index of the nested widget (`INVALID_WIDGET` means 'not used').

## Additional Inherited Members
Data Fields inherited from NWidgetBase
WidgetType | type {}
| Type of the widget / nested widget.
uint | fill_x = 0
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y = 0
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x = 0
| Horizontal resize step (`0` means not resizable).
uint | resize_y = 0
| Vertical resize step (`0` means not resizable).
uint | smallest_x = 0
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y = 0
| Smallest vertical size of the widget in a filled window.
uint | current_x = 0
| Current horizontal size (after resizing).
uint | current_y = 0
| Current vertical size (after resizing).
float | aspect_ratio = 0
| Desired aspect ratio of widget.
AspectFlags | aspect_flags = AspectFlag::ResizeX
| Which dimensions can be resized.
int | pos_x = 0
| Horizontal position of top-left corner of the widget in the window.
int | pos_y = 0
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding {}
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding {}
| Unscaled padding, for resize calculation.
NWidgetBase * | parent = nullptr
| Parent widget of this widget, automatically filled in when added to container.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Baseclass for container widgets.

Definition at line 471 of file widget_type.h.

## Constructor & Destructor Documentation

## ◆ NWidgetContainer()

NWidgetContainer::NWidgetContainer | ( | WidgetType | tp,
|  | WidgetID | index = `INVALID_WIDGET`
| ) |  |
| inline

Definition at line 473 of file widget_type.h.

## Member Function Documentation

## ◆ Add()

void NWidgetContainer::Add | ( | std::unique_ptr< NWidgetBase > && | wid | ) |

Append widget wid to container.

Parameters

  wid | Widget to append.

Definition at line 1292 of file widget.cpp.

References children, and NWidgetBase::parent.

Referenced by MakeWidgetTree(), and MakeWindowNWidgetTree().

## ◆ AdjustPaddingForZoom()

void NWidgetContainer::AdjustPaddingForZoom | ( |  | ) |
| overridevirtual

Reimplemented from NWidgetBase.

Definition at line 1280 of file widget.cpp.

## ◆ Clear()

void NWidgetContainer::Clear | ( | Window * | parent_window | ) |
| inline

Clears the container, deleting all widgets that were contained.

Parameters

  parent_window | Window that contains the container.

Definition at line 492 of file widget_type.h.

References children, and UnfocusWidgets().

Referenced by AddBadgeDropdownFilters().

## ◆ Draw()

void NWidgetContainer::Draw | ( | const Window * | w | ) |
| overridevirtual

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Reimplemented in NWidgetSocialPlugins, NWidgetToolbarContainer, NWidgetLayer, NWidgetStacked, and NWidgetMatrix.

Definition at line 1307 of file widget.cpp.

References children.

Referenced by NWidgetToolbarContainer::Draw().

## ◆ FillWidgetLookup()

void NWidgetContainer::FillWidgetLookup | ( | WidgetLookup & | widget_lookup | ) |
| overridevirtual

Fill the Window::widget_lookup with pointers to nested widgets in the tree.

Parameters

  widget_lookup | The WidgetLookup.

Reimplemented from NWidgetBase.

Reimplemented in NWidgetStacked.

Definition at line 1299 of file widget.cpp.

References children, and NWidgetBase::FillWidgetLookup().

Referenced by NWidgetStacked::FillWidgetLookup().

## ◆ GetWidgetFromPos()

NWidgetCore * NWidgetContainer::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| overridevirtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `nullptr` if no widget can be found.

Implements NWidgetBase.

Reimplemented in NWidgetStacked, and NWidgetMatrix.

Definition at line 1316 of file widget.cpp.

References children, NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::GetWidgetFromPos(), IsInsideBS(), NWidgetBase::pos_x, and NWidgetBase::pos_y.

## ◆ GetWidgetOfType()

NWidgetBase * NWidgetContainer::GetWidgetOfType | ( | WidgetType | tp | ) |
| overridevirtual

Retrieve a widget by its type.

Parameters

  tp | Widget type to search for.

Returns
  Returns the first widget of the specified type, or `nullptr` if no widget can be found.

Reimplemented from NWidgetBase.

Definition at line 1270 of file widget.cpp.

References children, NWidgetBase::GetWidgetOfType(), and NWidgetBase::type.

Referenced by MakeWindowNWidgetTree().

## ◆ IsEmpty()

bool NWidgetContainer::IsEmpty | ( |  | ) |
| inline

Return whether the container is empty.

Definition at line 483 of file widget_type.h.

References children.

Referenced by NWidgetLayer::SetupSmallestSize(), and NWidgetStacked::SetupSmallestSize().

## ◆ UnfocusWidgets()

void NWidgetContainer::UnfocusWidgets | ( | Window * | parent_window | ) |

Unfocuses the focused widget of the window, if the focused widget is contained inside the container.

Parameters

  parent_window | Window which contains this container.

Definition at line 3485 of file widget.cpp.

References children, Window::nested_focus, and Window::UnfocusFocusedWidget().

Referenced by Clear().

## Field Documentation

## ◆ children

std::vector<std::unique_ptr<NWidgetBase> > NWidgetContainer::children {}
| protected

Child widgets in container.

Definition at line 499 of file widget_type.h.

Referenced by Add(), NWidgetServerListHeader::AssignSizePosition(), NWidgetSmallmapDisplay::AssignSizePosition(), NWidgetToolbarContainer::AssignSizePosition(), NWidgetLayer::AssignSizePosition(), NWidgetStacked::AssignSizePosition(), NWidgetHorizontal::AssignSizePosition(), NWidgetVertical::AssignSizePosition(), NWidgetMatrix::AssignSizePosition(), Clear(), NWidgetSocialPlugins::Draw(), NWidgetLayer::Draw(), Draw(), NWidgetStacked::Draw(), NWidgetMatrix::Draw(), FillWidgetLookup(), NWidgetStacked::FillWidgetLookup(), GetWidgetFromPos(), NWidgetStacked::GetWidgetFromPos(), NWidgetMatrix::GetWidgetFromPos(), GetWidgetOfType(), IsEmpty(), NWidgetMatrix::SetCount(), NWidgetStacked::SetDisplayedPlane(), NWidgetServerListHeader::SetupSmallestSize(), NWidgetSmallmapDisplay::SetupSmallestSize(), NWidgetToolbarContainer::SetupSmallestSize(), NWidgetScenarioToolbarContainer::SetupSmallestSize(), NWidgetLayer::SetupSmallestSize(), NWidgetStacked::SetupSmallestSize(), NWidgetHorizontal::SetupSmallestSize(), NWidgetVertical::SetupSmallestSize(), NWidgetMatrix::SetupSmallestSize(), and UnfocusWidgets().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp